osl::move_probability::CheckmateIfCapture Class Reference

`#include <feature.h>`

Inheritance diagram for osl::move_probability::CheckmateIfCapture:

## Public Types

enum | { DIM = PTYPE_SIZE*PTYPE_SIZE }

## Public Member Functions

| CheckmateIfCapture ()
double | match (const StateInfo &info, const MoveInfo &move, int offset, const double *w) const
Public Member Functions inherited from osl::move_probability::Feature
| Feature (std::string n, size_t d)
virtual | ~Feature ()
std::string | name () const
size_t | dimension () const

## Static Public Member Functions

static bool | hasSafeCapture (NumEffectState &state, Move)
Static Public Member Functions inherited from osl::move_probability::Feature
static int | classifyEffect9 (const NumEffectState &state, Player player, Square to)

## Detailed Description

Definition at line 1223 of file move_probability/feature.h.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

Enumerator
DIM |

Definition at line 1226 of file move_probability/feature.h.

## Constructor & Destructor Documentation

## CheckmateIfCapture()

osl::move_probability::CheckmateIfCapture::CheckmateIfCapture | ( |  | ) |

inline

Definition at line 1229 of file move_probability/feature.h.

References DIM, and osl::move_probability::Feature::Feature().

## Member Function Documentation

## hasSafeCapture()

bool osl::move_probability::CheckmateIfCapture::hasSafeCapture | ( | NumEffectState & | state,
|  | Move | move )

static

Definition at line 204 of file feature_.cc.

References osl::checkmate::CheckmateIfCapture::effectiveAttack().

Referenced by match().

## match()

double osl::move_probability::CheckmateIfCapture::match | ( | const StateInfo & | info,
|  | const MoveInfo & | move,
|  | int | offset,
|  | const double * | w ) const

inline virtual

Implements osl::move_probability::Feature.

Definition at line 1232 of file move_probability/feature.h.

References osl::alt(), osl::Move::capturePtype(), osl::move_probability::StateInfo::copy, osl::GOLD, osl::Neighboring8Direct::hasEffect(), osl::SimpleState::hasPieceOnStand(), hasSafeCapture(), osl::NumEffectState::inCheck(), osl::SimpleState::kingSquare(), osl::move_probability::MoveInfo::move, osl::move_probability::StateInfo::move_candidate_exists, osl::move_probability::MoveInfo::player, osl::Move::ptype(), osl::PTYPE_EDGE, osl::PTYPE_EMPTY, osl::PTYPE_SIZE, osl::Move::ptypeO(), osl::move_probability::MoveInfo::see, osl::SILVER, osl::move_probability::StateInfo::state, and osl::Move::to().

The documentation for this class was generated from the following files:

- move_probability/feature.h
- feature_.cc